import { Message } from 'eris';
import { Client, Command } from '../class';

import Profile_Bio from './profile_bio';
import Profile_GitHub from './profile_github';
import Profile_Gitlab from './profile_gitlab';

export default class Profile extends Command {
  constructor(client: Client) {
    super(client);
    this.name = 'profile';
    this.description = 'Manages your profile on CR.';
    this.usage = `${this.client.config.prefix}profile <bio/github/gitlab> <new value>\n*Provide no value in subcommand to clear data.*`;
    this.permissions = 0;
    this.enabled = true;
    this.subcmds = [Profile_Bio, Profile_GitHub, Profile_Gitlab];
  }

  public async run(message: Message) {
    if (!await this.client.db.Member.exists({ userID: message.author.id })) {
      await this.client.db.Member.create({ userID: message.author.id });
    }

    this.error(message.channel, `Please specify a valid option to change. Choose from \`github\`, \`bio\` and \`gitlab\`. You can view your profile with \`${this.client.config.prefix}whois\`.`);
  }
}
